/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: getwch.c 1.2 89/11/30 $@(#)curses:screen/getwch.h"

#include	"curses_inc.h"


/*
**	Get a process code
*/

wgetwch(win)
WINDOW	*win;
	{
	int	c, n, type, width;
	char	buf[CSMAX];
	wchar_t wchar;
	int	length;

	/* get the first byte */
	if((c = wgetch(win)) == ERR)
		return ERR;

	type = TYPE(c);
	width = cswidth[type] - ((type == 1 || type == 2) ? 0 : 1);
	buf[0] = c;
	for(n = 1; n <= width; ++n)
		{
		if((c = wgetch(win)) == ERR)
			return ERR;
		if(TYPE(c) != 0)
			return ERR;
		buf[n] = c;
		}

	/* translate it to process code */
	length = mbtowc(&wchar, buf, n);
	return(wchar); 
	}
